﻿Module Module1
    Sub Sample()
        Dim FRAME_COUNT As System.UInt32
        Dim width As Euresys.SizeT
        Dim height As Euresys.SizeT
        Dim format As System.UInt64
        Dim size As Euresys.SizeT
        Dim timestamp As System.UInt64
        Dim imgPtr As System.IntPtr

        FRAME_COUNT = 20

        Using genTL As New Euresys.GenTL()
            Using converter As New Euresys.RGBConverter.RGBConverter(genTL)
                Using grabber As New Euresys.EGrabberCallbackOnDemand(genTL)
                    grabber.runScript("./config.js")

                    grabber.reallocBuffers(FRAME_COUNT)

                    grabber.start(FRAME_COUNT)

                    For frame As UInteger = 0 To FRAME_COUNT - 1
                        Using buffer As New Euresys.ScopedBuffer(grabber)
                            buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_SIZE_FILLED, size)
                            buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_TIMESTAMP, timestamp)
                            buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_BASE, imgPtr)

                            buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_WIDTH, width)
                            buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_HEIGHT, height)
                            buffer.getInfo(Euresys.gc.BUFFER_INFO_CMD.BUFFER_INFO_PIXELFORMAT, format)

                            System.Console.WriteLine("Acquisition Index: {0}", frame)
                            System.Console.WriteLine(" - Width: {0}", width)
                            System.Console.WriteLine(" - Height: {0}", height)
                            System.Console.WriteLine(" - Size: {0}", size)
                            System.Console.WriteLine(" - Timestamp: {0}.{1}", timestamp / 1000000, timestamp Mod 1000000)

                            Using conv As New Euresys.RGBConverter.BGR8(converter, imgPtr, format, width, height)
                                conv.saveToDisk("frame.NNN.jpeg", frame)
                            End Using
                        End Using
                    Next
                End Using
            End Using
        End Using
    End Sub


    Sub Main()
        Try
            Sample()
        Catch e As System.Exception
            System.Console.WriteLine(e.Message)
            System.Console.WriteLine(e.StackTrace)
            System.Console.WriteLine(e.Source)
        End Try
    End Sub

End Module
